#!/usr/local/bin/perl

require 5.002;

use English;

$Xsize = 1000;
$Ysize = 1000;

$border = 100;

$maxx = $Xsize - $border;
$maxy = $Ysize - $border;

$ave = 30;
$road = 15;
$block = 120;
$house = 30;

$prob_empty = .35;
$prob_big = .3;
$prob_residential = .35;

$big_perm = 20;
$residential_perm = 10;

#now convert prob's into the cdf
$prob_big += $prob_empty;
$prob_residential += $prob_big;

if ($#ARGV == 0) {
    $filename = $ARGV[0];
} else {
    $filename = 'city-map.obstacles';
}

open OUT,">$filename" or print "can't open '$filename' $ERRNO\n" and die; 

srand;

for ($curx = $border ; $curx < $maxx ; $curx += $block + $ave) {
    for ($cury = $border; $cury < $maxy ; $cury += $block + $ave) {
	$X = rand;
	if ($X < $prob_empty) {
	    next;
	} elsif ($X < $prob_big) {
	    make_box($curx, $cury, $block, $block, $big_perm);
	} else { #it's residential
	    for ($x = $curx; $x < $curx + $block; $x += $house + $road) {
		for ($y = $cury; $y < $cury + $block; $y += $house + $road) {
		    make_box($x, $y, $house, $house, $residential_perm);
		}
	    }
	}
    }
}

close(OUT);

sub make_box {
    my ($x,$y,$xdim,$ydim,$perm) = @ARG;
    my $buf = sprintf("obstacle %s %f,%f %f,%f perm %f",
		      box,
		      $x, $y, $x+$xdim, $y+$ydim,
		      $perm);
    print OUT <<"OBST"
#
# $buf
#
OBST
    
}
